/*
    Tracks models (c) by bastl.sk>

    Tracks models is licensed under a
    Creative Commons Attribution-NonCommercial 4.0 International License.

    You should have received a copy of the license along with this
    work. If not, see <http://creativecommons.org/licenses/by-nc/4.0/>.    
    
*/

$fn=72;

module lampa_kybel()
{
    difference() {
        cylinder(d=6.2, h=2.0, center=true);
        union () {
            translate([0,0,0.3]) cylinder(d=5.5, h=2.0, center=true);
        }
    }
}

module lampa_dekel()
{
        cylinder(d=6.6, h=0.4, center=true);
        translate([0,0,0.1]) cylinder(d=5.5, h=0.6, center=true);
        translate([0,0,0.2]) cylinder(d=1.4, h=0.8, center=true);
}

module lampa_spodok()
{
    difference() {
        union () {
            cylinder(d=6.2, h=0.1, center=true);
            translate([0,0,0.40]) cylinder(d1=6.2, d2=2, h=0.7, center=true);
        }
        union () {
            cylinder(d=1.2, h=4, center=true);
        }
    }
}

module lampa_stlp() {
    rotate([0,90,0]) difference() {
        union() {
            cylinder(d=1.3, h=32, center=true);
            translate([0,0,-25/2]) cylinder(d=1.8, h=7, center=true);
            translate([0,0, 30/2]) cylinder(d1=1.25, d2=2.1, h=2, center=true);
        }
        union () {
            cylinder(d=0.65, h=35, center=true);
            translate([0,0, 30/2]) cylinder(d1=0.7, d2=1.3, h=2.01, center=true);
        }
    }
}


module lampa_stlp_printable()
{
    module lampa_stlpy () {
        translate([0,-5,0]) lampa_stlp();
        translate([0,5,0]) lampa_stlp();
        difference() {
            cube([34.5,20,2], true);
            cube([32.5,20-2,3], true);
        }
        translate([0,-5,0]) difference () {
            union () {
                cube([34.5,1.75,0.2], true);
                translate([2.0,0,0]) cube([30.5,1.95,0.2], true);
            }
            union () {
                cube([31.7,3,0.4], true);
                cube([32.5,0.8,0.4], true);
                translate([0.5,0,0]) cube([32.5,1.3,0.4], true);
            }
        }
        translate([0,5,0]) difference () {
            union () {
                cube([34.5,1.75,0.2], true);
                translate([2.0,0,0]) cube([30.5,1.95,0.2], true);
            }
            union () {
                cube([31.7,3,0.4], true);
                cube([32.5,0.8,0.4], true);
                translate([0.5,0,0]) cube([32.5,1.3,0.4], true);
            }
        }
    }
    difference() {
        intersection () {
            lampa_stlpy();
            translate([0,0,5]) cube([40,25,10], true);
        }
        translate([0,0,1.2]) cube([35,0.5,2], true);
    }
}

module lampa_zostava(explode=true)
{
    x=1;
    translate([0,0,32+0.8+1+(explode?2*x:0)]) rotate([0,180,0]) color([1,1,1])lampa_kybel();
    translate([0,0,32+0.8+(explode?1*x:0)]) rotate([0,180,0]) color([1,1,1]) lampa_spodok();
    translate([0,0,32+2+0.8+(explode?3*x:0)]) color([0.3,0.3,0]) lampa_dekel();
    translate([0,0,32/2]) rotate([0,-90,0]) color([0.3,0.3,0]) lampa_stlp();
}


lampa_zostava(explode=true);

// Komponenty na tlac:

//lampa_kybel();
//lampa_spodok();
//lampa_dekel();
//lampa_stlp_printable();

